import { type RulesetDefinition } from '@stoplight/spectral-core';
import { type Logger } from '../logger';
type ProblemSeverity = 0 | 1 | 2 | 3;
export declare abstract class BaseLinter<TDefinition> {
    private readonly _spectral;
    private readonly _spectralDocument;
    private _results;
    protected constructor(definition: TDefinition, ruleset: RulesetDefinition);
    lint(): Promise<void>;
    logResults(logger: Logger): void;
    getSortedResults(): {
        message: string;
        path: string;
        severity: ProblemSeverity;
    }[];
    hasErrors(): boolean;
    private _getResults;
    private _simplifyPath;
    private _logResultMessage;
}
export {};
